/*  распознаватель слов и фраз по типу зоны Вернике в мозге.


*/


package word_sensor

import (
	"BOT/brain/gomeostas"
	"BOT/lib"
	"strings"
)

//////////////////////////////////////////  word_sensor.VerbalDetectin("активностный")

// текущий уникальный ID последней активной ветки дерева - результат детекции фразы - для дальнейшего использования
var DetectedUnicumID=0
// текущий тон фразы: 0 - обычный, 1 - восклицательный, 2- вопросительный
var DetectedNone=0

// Память о воспринятых фразах в текущем активном контексте:
type MemoryDetected struct {
	LastTreeID int // текущий уникальный ID последней активной ветки дерева
	Tone int //Тон: 0 - обычный, 1 - восклицательный, 2- вопросительный
	Mood int // настроение при передаче фразы с Пульта: Хорошее    -Плохое    -Игровое    -Учитель    -Агрессивное   -Защитное    -Протест
//!!! повышенный или вялый имеет приоритет над знаками кончания фразы (?!)
	// распознанная последовательсть
	VerbalStr []string
	VerbalID []int
	// список активировавшихся при распознании узлов дерева ???
	//var ActiveListTreeNods[]*WordTree
	// полная  распознанная часть
	VerbalDetected string
	// нераспознанный остаток
	VerbalEnd string
// индекс==ID активного базового контекста, значение - вес этого контекста
	ActveContextWeight map[int]int
}
//  массив памяти накапливается в течении дня, обрабатывается и очищается во сне
var MemoryDetectedArr []MemoryDetected
func addNewMemoryDetected(){
var new MemoryDetected
	new.LastTreeID=DetectedUnicumID
	new.Tone=DetectedNone // знак конца фразы: 0 - обычный, 1 - восклицательный, 2- вопросительный
	new.Mood=CurPultMood // настроение с Пульта: -повышенный -нормальный -вялый  -Хорошее    -Плохое    -Игровое    -Учитель    -Агрессивное   -Защитное    -Протест
	new.VerbalDetected=CurrentVerbalDetected
	new.VerbalEnd=CurrentVerbalEnd
	new.VerbalID=CurrentVerbalID
	new.VerbalStr=CurrentVerbalStr
	new.ActveContextWeight=gomeostas.GetActiveContextInfo()

	MemoryDetectedArr=append(MemoryDetectedArr,new)
}
//////////////////////////////////////////////


// распознанная последовательсть
var CurrentVerbalStr []string
var CurrentVerbalID []int
// список активировавшихся при распознании узлов дерева
var ActiveListTreeNods[]*WordTree
// полная  распознанная часть
var CurrentVerbalDetected string
// нераспознанный остаток
var CurrentVerbalEnd string
// настроение с ПУльта при передаче фразы
var CurPultMood=0
//////////////////////////////////////////////

// подошла очередь инициализации
func afetrInitWordTree(){

//	VerbalDetection("базовое состояние бота!")

//	StrDetection("активностью!")
}
//////////////////////////////////////////////

/*  распознавание фразы с Пульта - бывает только в нижнем регистре

 */
var wlev=0
func VerbalDetection(text string,moodID int)(string) {
	CurPultMood=moodID
	// стандартно разделить текст на короткие фразы, отправить на накопление
	strings:=addNewtempArr(text,true)
	for n := 0; n < len(strings); n++ {
		StrDetection(strings[n])
	}
	// ответ на Пульт:
	return "БУДЕТ СДЕЛАНО"
}

func StrDetection(text string){
	CurrentVerbalStr=nil
	CurrentVerbalID=nil
	CurrentVerbalEnd=""
	ActiveListTreeNods=nil

	// первый символ
	r := []rune(text)
	// основа дерева
	cnt:=len(VernikeWordTree.Children)
	for n := 0; n < cnt; n++ {
		smblNode:=VernikeWordTree.Children[n]
		rt := []rune(smblNode.Word)
		if r[0]==rt[0]{
			ActiveListTreeNods=append(ActiveListTreeNods,&smblNode)
			CurrentVerbalStr=append(CurrentVerbalStr,smblNode.Word)
			CurrentVerbalID=append(CurrentVerbalID,smblNode.ID)

			cldrn:=VernikeWordTree.Children[n].Children;
			cnt:=len(cldrn)
			for n := 0; n < cnt; n++ {
				wlev=1
				res:=getWordTreeNode(wlev, r[1:], &cldrn[n])
				if res{
					break
				}
			}
		}
	}

	// полная  распознанная часть
	CurrentVerbalDetected=""
	for n := 0; n < len(CurrentVerbalStr); n++ {
		CurrentVerbalDetected+=CurrentVerbalStr[n]
	}
	// нераспознанный остаток
	len1:=len(text)
	len2:=len(CurrentVerbalDetected)
	if len1>len2 {
		CurrentVerbalEnd = text[len(CurrentVerbalDetected):]
	}
// уникальный ID последней ветки
	DetectedUnicumID=ActiveListTreeNods[len(ActiveListTreeNods)-1].ID
	// определить текущий тон фразы: 0 - обычный, 1 - восклицательный, 2- вопросительный
	DetectedNone=0  // TODO Надо бы смотреть не только в остатке, но и в последнем найденном!
	if strings.Contains(CurrentVerbalEnd, "!"){
		DetectedNone=1
	}
	if strings.Contains(CurrentVerbalEnd, "?"){
		DetectedNone=2
	}
	// добавить в стек памяти распознанных
	addNewMemoryDetected()
return
}
/////////////////////////////////////////////
func getWordTreeNode(level int,word []rune,wt *WordTree)(bool){

	rt := []rune(wt.Word)

	var path=[]rune("")
	var ost=[]rune("")
	if len(rt)<=len(word) {
		path=word[:len(rt)]
		ost = word[len(rt):]
	}

	res:=lib.RuneCompare(path,rt)

	if(res==0){// часть слова совпала с узлом,  пишем текущий результат совпадения
		ActiveListTreeNods=append(ActiveListTreeNods,wt)
		CurrentVerbalStr=append(CurrentVerbalStr,wt.Word)
		CurrentVerbalID=append(CurrentVerbalID,wt.ID)

		// если word не остается ничего или если дальше нет дочек то конец
	o:= word[len(path):]
	if len(o)==0 || wt.Children==nil{
		return true
	}
	}

	// смотрим дальше
		cnt:=len(wt.Children)
		for n := 0; n < cnt; n++ {
			level++
			res:=getWordTreeNode(level,ost, &wt.Children[n])
			if res{
				return res
			}
		}

	return false
}
//////////////////////////////////////////////////////

